/**************************************************************************
 *
 *          Copyright (c) 2002, SeeBeyond Technology Corporation,
 *          All Rights Reserved
 *
 *          This program, and all the routines referenced herein,
 *          are the proprietary properties and trade secrets of
 *          SEEBEYOND TECHNOLOGY CORPORATION.
 *
 *          Except as provided for by license agreement, this
 *          program shall not be duplicated, used, or disclosed
 *          without  written consent signed by an officer of
 *          SEEBEYOND TECHNOLOGY CORPORATION.
 *
 ***************************************************************************/
package com.stc.connector.httpadapter.http;

/**
 * DOCUMENT ME!
 *
 * @author James D. Tran
 * @version $Revision: 1.2 $
 */
public class NameValuePair {
    /** name */
    protected String name;
    /** value */
    protected String value;

    /**
     * Constructs a NameValuePair.
     */
    public NameValuePair() {
    }

    /**
     * Constructs a NameValuePair.
     *
     * @param name The name portion of the NameValuePair
     * @param value The value portion of the NameValuePair
     */
    public NameValuePair(String name, String value) {
        this.name = new String(name);
        this.value = new String(value);
    }

    /**
     * Gets the name portion of the NameValuePair
     *
     * @return Name portion of the NameValuePair
     */
    public String getName() {
        return new String(name);
    }

    /**
     * Gets the value portion of the NameValuePair
     *
     * @return Value portion of the NameValuePair
     */
    public String getValue() {
        return new String(value);
    }

    /**
     * Sets the name portion of the NameValuePair.
     *
     * @param name Name portion of the NameValuePair
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Sets the value portion of the NameValuePair
     *
     * @param value The Value portion of the NameValuePair
     */
    public void setValue(String value) {
        this.value = value;
    }

    /**
     * Returns a String representation of the NameValuePair
     *
     * @return String representation in the following format<BR><B>"name:
     *         value"</B>
     */
    public String toString() {
        return new String(name + ": " + value);
    }
}
