/**************************************************************************
 *
 *          Copyright (c) 2002, SeeBeyond Technology Corporation,
 *          All Rights Reserved
 *
 *          This program, and all the routines referenced herein,
 *          are the proprietary properties and trade secrets of
 *          SEEBEYOND TECHNOLOGY CORPORATION.
 *
 *          Except as provided for by license agreement, this
 *          program shall not be duplicated, used, or disclosed
 *          without  written consent signed by an officer of
 *          SEEBEYOND TECHNOLOGY CORPORATION.
 *
 ***************************************************************************/
package com.stc.connector.httpadapter.http;

/**
 * DOCUMENT ME!
 *
 * @author James D. Tran
 * @version $Revision: 1.2 $
 */
public class QueryPair {
    String name;
    String value;
    String urlencodedName;
    String urlencodedValue;

    /**
     * Constructs a QueryPair
     */
    public QueryPair() {
    }

    /**
     * Constructs a QueryPair
     *
     * @param name The Name portion of the query pair
     * @param value The Value portion of the query pair
     */
    public QueryPair(String name, String value) {
        this.name = new String(name);
        this.urlencodedName = new String(URLEncoder2.encode(name));
        this.value = new String(value);
        this.urlencodedValue = new String(URLEncoder2.encode(value));
    }

    /**
     * Sets the name portion of the query pair.
     *
     * @param name The Name portion of the query
     */
    public void setName(String name) {
        this.name = new String(name);
        this.urlencodedName = new String(URLEncoder2.encode(name));
    }

    /**
     * Gets the name portion of the query pair.
     *
     * @return Name portion of the query
     */
    public String getName() {
        return name;
    }

    /**
     * Sets the value portion of the query pair. The value will be url encoded.
     *
     * @param value The Value portion of the query
     */
    public void setValue(String value) {
        this.value = new String(value);
        this.urlencodedValue = new String(URLEncoder2.encode(value));
    }

    /**
     * Gets the value portion of the query pair.
     *
     * @return Value portion of the query
     */
    public String getValue() {
        return value;
    }

    /**
     * Returns the name/value query pair as urlencoded strings.
     *
     * @return URL encoded name/value pair string.
     */
    public String toString() {
        return new String(urlencodedName + "=" + urlencodedValue);
    }
}
