/**************************************************************************
 *
 *          Copyright (c) 2002, SeeBeyond Technology Corporation,
 *          All Rights Reserved
 *
 *          This program, and all the routines referenced herein,
 *          are the proprietary properties and trade secrets of
 *          SEEBEYOND TECHNOLOGY CORPORATION.
 *
 *          Except as provided for by license agreement, this
 *          program shall not be duplicated, used, or disclosed
 *          without  written consent signed by an officer of
 *          SEEBEYOND TECHNOLOGY CORPORATION.
 *
 ***************************************************************************/
package com.stc.connector.httpadapter.http;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.BitSet;


/**
 * DOCUMENT ME!
 *
 * @author James D. Tran
 * @version $Revision: 1.1 $
 */
public class URLEncoder2 {
    static final int CASEDIFF = ('a' - 'A');
    static String encoding = "ASCII";
    static BitSet dontNeedEncoding;

    static {
        dontNeedEncoding = new BitSet(256);

        int i;

        for (i = 'a'; i <= 'z'; i++) {
            dontNeedEncoding.set(i);
        }

        for (i = 'A'; i <= 'Z'; i++) {
            dontNeedEncoding.set(i);
        }

        for (i = '0'; i <= '9'; i++) {
            dontNeedEncoding.set(i);
        }

        dontNeedEncoding.set(' ');
        dontNeedEncoding.set('-');
        dontNeedEncoding.set('_');
        dontNeedEncoding.set('.');
        dontNeedEncoding.set('*');
    }

    private URLEncoder2() {
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     *
     * @todo Document: Getter for Encoding attribute of the URLEncoder2 class
     */
    public static String getEncoding() {
        return encoding;
    }

    /**
     * DOCUMENT ME!
     *
     * @param s encoding
     *
     * @todo Document: Setter for Encoding attribute of the URLEncoder2 class
     */
    public static void setEncoding(String s) {
        encoding = s;
    }

    /**
     * DOCUMENT ME!
     *
     * @param s - string to encode
     *
     * @return DOCUMENT ME!
     *
     * @todo Document this method
     */
    public static String encode(String s) {
        int maxBytesPerChar = 10;
        StringBuffer out = new StringBuffer(s.length());
        ByteArrayOutputStream buf = new ByteArrayOutputStream(maxBytesPerChar);

        try {
            OutputStreamWriter writer = new OutputStreamWriter(buf, encoding);

            for (int i = 0; i < s.length(); i++) {
                int c = (int) s.charAt(i);

                if (dontNeedEncoding.get(c)) {
                    if (c == ' ') {
                        c = '+';
                    }

                    out.append((char) c);
                } else {
                    // convert to external encoding before hex conversion
                    try {
                        writer.write(c);
                        writer.flush();
                    } catch (IOException e) {
                        buf.reset();
                        continue;
                    }

                    byte[] ba = buf.toByteArray();

                    for (int j = 0; j < ba.length; j++) {
                        out.append('%');

                        char ch = Character.forDigit(
                                (ba[j] >> 4) & 0xF,
                                16);

                        if (Character.isLetter(ch)) {
                            ch -= CASEDIFF;
                        }

                        out.append(ch);
                        ch = Character.forDigit(
                                ba[j] & 0xF,
                                16);

                        if (Character.isLetter(ch)) {
                            ch -= CASEDIFF;
                        }

                        out.append(ch);
                    }

                    buf.reset();
                }
            }
        } catch (Exception e) {
            System.out.println(e);
            System.out.println(e.getMessage());
        }

        return out.toString();
    }
}
